package rajola.test;

import java.util.List;

import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.BasicGame;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;

import rajola.pipeline.BasicTile;
import rajola.pipeline.Tile;
import rajola.pipeline.sprites.TileSprite;
import rajola.pipeline.sprites.TileSpriteSheet;

public class SpriteSheetTest extends BasicGame {

	private TileSpriteSheet spriteSheet;
	private TileSpriteSheet spriteSheet2;
	private TileSpriteSheet animatedSheet;
	private TileSprite sprite;
	private TileSprite animatedSprite;
	private Tile tile;
	
	private List<TileSprite> sprites;

	public SpriteSheetTest() {
		super("Rajola SPRITE SHEET TEST");
	}

	public static void main(String args[]) throws SlickException {
		AppGameContainer gc = new AppGameContainer(new SpriteSheetTest());
		gc.setDisplayMode(600, 800, false);
		gc.start();
	}

	@Override
	public void render(GameContainer gc, Graphics g) throws SlickException {
		int yOffset = 50;
		int xOffset = 50;
		for (int i = 0; i < 4; i++) {
			spriteSheet.getTileImage(i % 2, (int)Math.floor(i / 2)).draw((i * 40) + xOffset , yOffset);
		}
		spriteSheet2.getFullImage().draw(100 ,100);
		sprite.render(100, 150);
		for(int i = 0 ; i < sprites.size() ; i++) {
			sprites.get(i).render(50 + (i * 2 *sprites.get(i).getWidth()), 200);
		}
		tile.render(0, 0);
	}

	@Override
	public void init(GameContainer gc) throws SlickException {
		spriteSheet = new TileSpriteSheet("res/test.png", 16);
		animatedSheet = new TileSpriteSheet("res/test.png", 16);
		spriteSheet2 = new TileSpriteSheet("res/test.png");
		sprite = new TileSprite(spriteSheet2.getFullImage());
		sprites = TileSprite.autoConstructSprites(spriteSheet.getTiles());
		animatedSprite = new TileSprite(1000 , animatedSheet.getTiles());
		tile = new BasicTile(0 , animatedSprite);
	}

	@Override
	public void update(GameContainer gc, int d) throws SlickException {
		tile.update(d);
	}
}
